// MessageTextView version 1.0
// by Al.V.Sarikov.
// Kherson, Ukraine, 2006.
// E-mail: avix@ukrpost.net.
// Home page: http://avix.pp.ru.

// This class provides an underlined and clickable BStringView.
// Being clicked it sends message the same as BButton control. 

// Class is created on base of and using code of URLView class of version 2.11
// written by William Kakes of Tall Hill Software (http://www.tallhill.com).

#include <Cursor.h>
#include <Invoker.h>
#include <StringView.h>

class MessageTextView:public BStringView, public BInvoker
{
 public:
  MessageTextView(BRect frame, const char *name, const char *label, BMessage *msg,
                  uint32 resizingMode=B_FOLLOW_LEFT|B_FOLLOW_TOP,
                  uint32 flags=B_WILL_DRAW );
  ~MessageTextView();
  
  virtual void AttachedToWindow();
  virtual void Draw(BRect updateRect);
  virtual void MouseDown(BPoint point);
  virtual void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
  virtual void MouseUp(BPoint point);
  virtual void WindowActivated(bool active);
  
  virtual bool IsEnabled();
  virtual rgb_color Color() const;
  virtual void SetColor(rgb_color color);
  virtual void SetColor(uchar red, uchar green, uchar blue, uchar alpha=255);
  virtual rgb_color ClickColor() const;
  virtual void SetClickColor(rgb_color color);
  virtual void SetClickColor(uchar red, uchar green, uchar blue, uchar alpha=255);
  virtual rgb_color DisabledColor() const;
  virtual void SetDisabledColor(rgb_color color);
  virtual void SetDisabledColor(uchar red, uchar green, uchar blue, uchar alpha=255);
  virtual void SetEnabled(bool enabled);
  virtual rgb_color HoverColor() const;
  virtual void SetHoverColor(rgb_color color);
  virtual void SetHoverColor(uchar red, uchar green, uchar blue, uchar alpha=255);
  virtual bool IsHoverEnabled();
  virtual void SetHoverEnabled(bool hover);
  virtual int UnderlineThickness();
  virtual void SetUnderlineThickness(int thickness);
 private:
  BRect GetTextRect();
  void Redraw();
  
  rgb_color color;
  rgb_color clickColor;
  rgb_color hoverColor;
  rgb_color disabledColor;
  bool enabled;
  bool hoverEnabled;
  int underlineThickness;
  bool selected;
  bool hovering;
  const BCursor *linkCursor;
};
